<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>SimulationConfig &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Observation_Log" href="../outputs/observation_log.html" />
    <link rel="prev" title="Scenery" href="scenery.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../30_configs_in_depth.html">Configs in Depth</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="profilescatalog.html">ProfilesCatalog</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario.html">Scenario</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario_api_support.html">Scenario API Support</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenery.html">Scenery</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">SimulationConfig</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#profilescatalog">ProfilesCatalog</a></li>
<li class="toctree-l3"><a class="reference internal" href="#experiment">Experiment</a></li>
<li class="toctree-l3"><a class="reference internal" href="#scenario">Scenario</a></li>
<li class="toctree-l3"><a class="reference internal" href="#environment">Environment</a></li>
<li class="toctree-l3"><a class="reference internal" href="#observations">Observations</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../outputs/observation_log.html">Observation_Log</a></li>
<li class="toctree-l4"><a class="reference internal" href="../outputs/observation_repository.html">Observation_EntityRepository</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#spawners">Spawners</a></li>
<li class="toctree-l3"><a class="reference internal" href="#full-example">Full Example</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="staticsystemconfig.html">Static SystemConfig</a></li>
<li class="toctree-l2"><a class="reference internal" href="systemconfigblueprint.html">SystemConfigBlueprint</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../30_configs_in_depth.html">Configs in Depth</a></li>
      <li class="breadcrumb-item active">SimulationConfig</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/user_guide/configs/simulationconfig.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="simulationconfig">
<span id="id1"></span><h1>SimulationConfig<a class="headerlink" href="#simulationconfig" title="Link to this heading"></a></h1>
<p>This file describes the high level parameters of a simulation invocation (i.e. an experiment).
It contains the basic experiment settings like number of runs and random seed, the environment definition,
the parametrization of the output (more precisely the observation modules) and the definition of the spawners.
The path to the SimulationConfig is given as command line argument (or defaulted) and all other configs are directly
or indirectly refered to in the SimulationConfig.
Several parameters depend on probabilities.
Each invocation then rolls for said probabilities.
All probabilities need to add up to 1.0.</p>
<p>The simulationConfig.xml consists of the following sections:</p>
<ul class="simple">
<li><p><a class="reference internal" href="#simulationconfig-profilescatalog"><span class="std std-ref">ProfilesCatalog</span></a></p></li>
<li><p><a class="reference internal" href="#simulationconfig-experiment"><span class="std std-ref">Experiment</span></a></p></li>
<li><p><a class="reference internal" href="#simulationconfig-scenario"><span class="std std-ref">Scenario</span></a></p></li>
<li><p><a class="reference internal" href="#simulationconfig-environment"><span class="std std-ref">Environment</span></a></p></li>
<li><p><a class="reference internal" href="#simulationconfig-observations"><span class="std std-ref">Observations</span></a></p></li>
<li><p><a class="reference internal" href="#simulationconfig-spawners"><span class="std std-ref">Spawners</span></a></p></li>
</ul>
<section id="profilescatalog">
<span id="simulationconfig-profilescatalog"></span><h2>ProfilesCatalog<a class="headerlink" href="#profilescatalog" title="Link to this heading"></a></h2>
<p>Specifies the <a class="reference internal" href="profilescatalog.html#profilescatalog"><span class="std std-ref">ProfilesCatalog</span></a> for the experiment.</p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">  </span><span class="nt">&lt;ProfilesCatalog&gt;</span>ProfilesCatalog.xml<span class="nt">&lt;/ProfilesCatalog&gt;</span>
</pre></div>
</div>
</section>
<section id="experiment">
<span id="simulationconfig-experiment"></span><h2>Experiment<a class="headerlink" href="#experiment" title="Link to this heading"></a></h2>
<p>Specifies the general experiment setup, not specific to a single invocation.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Tag</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Mandatory</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>ExperimentId</p></td>
<td><p>Id of the experiment</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-odd"><td><p>NumberOfInvocations</p></td>
<td><p>Number of invocation in the experiment.
For each invocation probabilities are rerolled.</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-even"><td><p>RandomSeed</p></td>
<td><p>Random seed for the entire experiment.
Must be within the bounds of an unsigned integer.</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-odd"><td><p>Libraries</p></td>
<td><p>Name of the core module Libraries to use.
If not specified the default name is assumed.</p></td>
<td><p>yes</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">  </span><span class="nt">&lt;Experiment&gt;</span>
<span class="w">    </span><span class="nt">&lt;ExperimentID&gt;</span>123<span class="nt">&lt;/ExperimentID&gt;</span>
<span class="w">    </span><span class="nt">&lt;NumberOfInvocations&gt;</span>1<span class="nt">&lt;/NumberOfInvocations&gt;</span>
<span class="w">    </span><span class="nt">&lt;RandomSeed&gt;</span>532725206<span class="nt">&lt;/RandomSeed&gt;</span>
<span class="w">    </span><span class="nt">&lt;Libraries&gt;</span>
<span class="w">      </span><span class="nt">&lt;WorldLibrary&gt;</span>World_OSI<span class="nt">&lt;/WorldLibrary&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Libraries&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Experiment&gt;</span>
</pre></div>
</div>
</section>
<section id="scenario">
<span id="simulationconfig-scenario"></span><h2>Scenario<a class="headerlink" href="#scenario" title="Link to this heading"></a></h2>
<p>This section contains information about the scenario setup for the experiment. This information does not change between invocations.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Tag</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Mandatory</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenScenarioFile</p></td>
<td><p>Name of the scenario file</p></td>
<td><p>yes</p></td>
</tr>
</tbody>
</table>
<p><strong>Example</strong></p>
<p>This experiment uses the “HighwayScenario.xosc” scenario file.</p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">  </span><span class="nt">&lt;Scenario&gt;</span>
<span class="w">    </span><span class="nt">&lt;OpenScenarioFile&gt;</span>Scenario.xosc<span class="nt">&lt;/OpenScenarioFile&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Scenario&gt;</span>
</pre></div>
</div>
</section>
<section id="environment">
<span id="simulationconfig-environment"></span><h2>Environment<a class="headerlink" href="#environment" title="Link to this heading"></a></h2>
<p>This section contains information about the world and the general environment inside the simulation. Every invocation re-rolls the environment probabilities.
All probabilities need to add up to 1.0.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Tag</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Mandatory</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>TimeOfDay</p></td>
<td><p><strong>Currently unused.</strong> Time of day ranging from 1-24 [h].</p></td>
<td><p>1+ entry</p></td>
</tr>
<tr class="row-odd"><td><p>VisibilityDistance</p></td>
<td><p>Defines how far a human driver can see [m].</p></td>
<td><p>1+ entry</p></td>
</tr>
<tr class="row-even"><td><p>Friction</p></td>
<td><p>Friction on the road. Used by DynamicsRegularDriving and LimiterAccelerationVehicleComponents.</p></td>
<td><p>1+ entry</p></td>
</tr>
<tr class="row-odd"><td><p>Weather</p></td>
<td><p><strong>Currently unused.</strong> Weather as string</p></td>
<td><p>1+ entry</p></td>
</tr>
<tr class="row-even"><td><p>TrafficRules</p></td>
<td><p>Defines which set of TrafficRules to use from the ProfilesCatalog</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-odd"><td><p>TurningRates</p></td>
<td><p>Defines the turning rates for random route generation</p></td>
<td><p>no</p></td>
</tr>
</tbody>
</table>
<p><strong>Example</strong></p>
<p>Every invocation has the time set to 15:00.
In 70% of all invocation drivers can see 125 meter and for the other 30% of invocations the drivers can see 250 meter.
Every invocation has a friction of 0.3.
Every invocation has sunny weather.</p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">  </span><span class="nt">&lt;Environment&gt;</span>
<span class="w">    </span><span class="nt">&lt;TimeOfDays&gt;</span>
<span class="w">      </span><span class="nt">&lt;TimeOfDay</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.4&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;15&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;TimeOfDay</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.6&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;18&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/TimeOfDays&gt;</span>
<span class="w">    </span><span class="nt">&lt;VisibilityDistances&gt;</span>
<span class="w">      </span><span class="nt">&lt;VisibilityDistance</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.7&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;300&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;VisibilityDistance</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.3&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;400&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/VisibilityDistances&gt;</span>
<span class="w">    </span><span class="nt">&lt;Frictions&gt;</span>
<span class="w">      </span><span class="nt">&lt;Friction</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;1.0&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;1.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Frictions&gt;</span>
<span class="w">    </span><span class="nt">&lt;Weathers&gt;</span>
<span class="w">      </span><span class="nt">&lt;Weather</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.5&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Rainy&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;Weather</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.5&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Snowy&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Weathers&gt;</span>
<span class="w">    </span><span class="nt">&lt;TrafficRules&gt;</span>DE<span class="nt">&lt;/TrafficRules&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Environment&gt;</span>
</pre></div>
</div>
<p><strong>TurningRates</strong></p>
<p>If routes are not defined in the Scenario, they are randomly generated.
Starting at the current agent position at each junction a random connector is chosen based on the weights given in the TurningRates element, until the route terminates at a road without successors or a maximum depth is reached.
If for a pair of incoming road / connector no weight is given, it is defaulted to 1.
At the below example an agent coming from road “R1” has a 1/3 chance of selecting “R1-2” and a 2/3 chance of selecting “R1-3”.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Incoming</p></td>
<td><p>Id of the incoming road</p></td>
</tr>
<tr class="row-odd"><td><p>Outgoing</p></td>
<td><p>Id of the connector</p></td>
</tr>
<tr class="row-even"><td><p>Weight</p></td>
<td><p>Weight for this pair</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">    </span><span class="nt">&lt;TurningRates&gt;</span>
<span class="w">      </span><span class="nt">&lt;TurningRate</span><span class="w"> </span><span class="na">Incoming=</span><span class="s">&quot;R1&quot;</span><span class="w"> </span><span class="na">Outgoing=</span><span class="s">&quot;R1-2&quot;</span><span class="w"> </span><span class="na">Weight=</span><span class="s">&quot;1.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;TurningRate</span><span class="w"> </span><span class="na">Incoming=</span><span class="s">&quot;R1&quot;</span><span class="w"> </span><span class="na">Outgoing=</span><span class="s">&quot;R1-3&quot;</span><span class="w"> </span><span class="na">Weight=</span><span class="s">&quot;2.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;TurningRate</span><span class="w"> </span><span class="na">Incoming=</span><span class="s">&quot;R2&quot;</span><span class="w"> </span><span class="na">Outgoing=</span><span class="s">&quot;R2-1&quot;</span><span class="w"> </span><span class="na">Weight=</span><span class="s">&quot;1.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;TurningRate</span><span class="w"> </span><span class="na">Incoming=</span><span class="s">&quot;R2&quot;</span><span class="w"> </span><span class="na">Outgoing=</span><span class="s">&quot;R2-3&quot;</span><span class="w"> </span><span class="na">Weight=</span><span class="s">&quot;1.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;TurningRate</span><span class="w"> </span><span class="na">Incoming=</span><span class="s">&quot;R3&quot;</span><span class="w"> </span><span class="na">Outgoing=</span><span class="s">&quot;R3-1&quot;</span><span class="w"> </span><span class="na">Weight=</span><span class="s">&quot;2.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;TurningRate</span><span class="w"> </span><span class="na">Incoming=</span><span class="s">&quot;R3&quot;</span><span class="w"> </span><span class="na">Outgoing=</span><span class="s">&quot;R3-2&quot;</span><span class="w"> </span><span class="na">Weight=</span><span class="s">&quot;1.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/TurningRates&gt;</span>
</pre></div>
</div>
</section>
<section id="observations">
<span id="simulationconfig-observations"></span><h2>Observations<a class="headerlink" href="#observations" title="Link to this heading"></a></h2>
<p>In this section all observation libraries are defined with their parameters.
A specific library is loaded by adding an entry to the <cite>Observations</cite> tag:</p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Observations&gt;</span>
<span class="w">  </span><span class="cm">&lt;!-- first observer --&gt;</span>
<span class="w">  </span><span class="nt">&lt;Observation&gt;</span>
<span class="w">    </span><span class="nt">&lt;Library&gt;</span>THE_OBSERVATION_LIBRARY<span class="nt">&lt;/Library&gt;</span>
<span class="w">    </span><span class="cm">&lt;!-- observer specific parameter --&gt;</span>
<span class="w">    </span><span class="nt">&lt;Parameters&gt;</span>
<span class="w">      </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;THE_KEY&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;THE_VALUE&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;ANOTHER_KEY&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span>...
<span class="w">    </span><span class="nt">&lt;/Parameters&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Observation&gt;</span>
<span class="w">  </span><span class="cm">&lt;!-- second observer --&gt;</span>
<span class="w">  </span><span class="nt">&lt;Observation&gt;</span>
<span class="w">     </span>...
<span class="w">  </span><span class="nt">&lt;/Observation&gt;</span>
<span class="nt">&lt;/Observations&gt;</span>
</pre></div>
</div>
<p>Here, the <code class="docutils literal notranslate"><span class="pre">Library</span></code> tag contains the name of the library, and <code class="docutils literal notranslate"><span class="pre">Parameters</span></code> contain an optional list of key/value pairs, specific for each observer.</p>
<p>Please refer to the documentation of the individual observers for available parameters:</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="../outputs/observation_log.html">Observation_Log</a></li>
<li class="toctree-l1"><a class="reference internal" href="../outputs/observation_repository.html">Observation_EntityRepository</a></li>
</ul>
</div>
</section>
<section id="spawners">
<span id="simulationconfig-spawners"></span><h2>Spawners<a class="headerlink" href="#spawners" title="Link to this heading"></a></h2>
<p>In this section the spawners are defined with their Profile (defined in the ProfilesCatalog).
The same library can be loaded multiple times with different profiles.
A spawner is either of type “PreRun”, meaning it is triggered only once at the start of the simulation, or “Runtime”, meaning it is triggered in every timestep.
If different spawners are to be triggered at the same time the spawner with the highest priority is triggered first.</p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">  </span><span class="nt">&lt;Spawners&gt;</span>
<span class="w">    </span><span class="nt">&lt;Spawner&gt;</span>
<span class="w">      </span><span class="nt">&lt;Library&gt;</span>SpawnerPreRunCommon<span class="nt">&lt;/Library&gt;</span>
<span class="w">      </span><span class="nt">&lt;Type&gt;</span>PreRun<span class="nt">&lt;/Type&gt;</span>
<span class="w">      </span><span class="nt">&lt;Priority&gt;</span>0<span class="nt">&lt;/Priority&gt;</span>
<span class="w">      </span><span class="nt">&lt;Profile&gt;</span>DefaultPreRunCommon<span class="nt">&lt;/Profile&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Spawner&gt;</span>
<span class="w">    </span><span class="nt">&lt;Spawner&gt;</span>
<span class="w">      </span><span class="nt">&lt;Library&gt;</span>SpawnerRuntimeCommon<span class="nt">&lt;/Library&gt;</span>
<span class="w">      </span><span class="nt">&lt;Type&gt;</span>Runtime<span class="nt">&lt;/Type&gt;</span>
<span class="w">      </span><span class="nt">&lt;Priority&gt;</span>0<span class="nt">&lt;/Priority&gt;</span>
<span class="w">      </span><span class="nt">&lt;Profile&gt;</span>DefaultRuntimeCommon<span class="nt">&lt;/Profile&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Spawner&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Spawners&gt;</span>
</pre></div>
</div>
</section>
<section id="full-example">
<h2>Full Example<a class="headerlink" href="#full-example" title="Link to this heading"></a></h2>
<div class="literal-block-wrapper docutils container" id="id2">
<div class="code-block-caption"><span class="caption-text">simulationConfig.xml</span><a class="headerlink" href="#id2" title="Link to this code"></a></div>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="linenos"> 1</span><span class="cp">&lt;?xml version=&#39;1.0&#39; encoding=&#39;UTF-8&#39;?&gt;</span>
<span class="linenos"> 2</span><span class="nt">&lt;simulationConfig</span><span class="w"> </span><span class="na">SchemaVersion=</span><span class="s">&quot;0.8.2&quot;</span><span class="nt">&gt;</span>
<span class="linenos"> 3</span><span class="w">  </span><span class="nt">&lt;ProfilesCatalog&gt;</span>ProfilesCatalog.xml<span class="nt">&lt;/ProfilesCatalog&gt;</span>
<span class="linenos"> 4</span><span class="w">  </span><span class="nt">&lt;Experiment&gt;</span>
<span class="linenos"> 5</span><span class="w">    </span><span class="nt">&lt;ExperimentID&gt;</span>123<span class="nt">&lt;/ExperimentID&gt;</span>
<span class="linenos"> 6</span><span class="w">    </span><span class="nt">&lt;NumberOfInvocations&gt;</span>1<span class="nt">&lt;/NumberOfInvocations&gt;</span>
<span class="linenos"> 7</span><span class="w">    </span><span class="nt">&lt;RandomSeed&gt;</span>532725206<span class="nt">&lt;/RandomSeed&gt;</span>
<span class="linenos"> 8</span><span class="w">    </span><span class="nt">&lt;Libraries&gt;</span>
<span class="linenos"> 9</span><span class="w">      </span><span class="nt">&lt;WorldLibrary&gt;</span>World_OSI<span class="nt">&lt;/WorldLibrary&gt;</span>
<span class="linenos">10</span><span class="w">    </span><span class="nt">&lt;/Libraries&gt;</span>
<span class="linenos">11</span><span class="w">  </span><span class="nt">&lt;/Experiment&gt;</span>
<span class="linenos">12</span><span class="w">  </span><span class="nt">&lt;Scenario&gt;</span>
<span class="linenos">13</span><span class="w">    </span><span class="nt">&lt;OpenScenarioFile&gt;</span>Scenario.xosc<span class="nt">&lt;/OpenScenarioFile&gt;</span>
<span class="linenos">14</span><span class="w">  </span><span class="nt">&lt;/Scenario&gt;</span>
<span class="linenos">15</span><span class="w">  </span><span class="nt">&lt;Environment&gt;</span>
<span class="linenos">16</span><span class="w">    </span><span class="nt">&lt;TimeOfDays&gt;</span>
<span class="linenos">17</span><span class="w">      </span><span class="nt">&lt;TimeOfDay</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.4&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;15&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">18</span><span class="w">      </span><span class="nt">&lt;TimeOfDay</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.6&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;18&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">19</span><span class="w">    </span><span class="nt">&lt;/TimeOfDays&gt;</span>
<span class="linenos">20</span><span class="w">    </span><span class="nt">&lt;VisibilityDistances&gt;</span>
<span class="linenos">21</span><span class="w">      </span><span class="nt">&lt;VisibilityDistance</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.7&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;300&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">22</span><span class="w">      </span><span class="nt">&lt;VisibilityDistance</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.3&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;400&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">23</span><span class="w">    </span><span class="nt">&lt;/VisibilityDistances&gt;</span>
<span class="linenos">24</span><span class="w">    </span><span class="nt">&lt;Frictions&gt;</span>
<span class="linenos">25</span><span class="w">      </span><span class="nt">&lt;Friction</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;1.0&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;1.0&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">26</span><span class="w">    </span><span class="nt">&lt;/Frictions&gt;</span>
<span class="linenos">27</span><span class="w">    </span><span class="nt">&lt;Weathers&gt;</span>
<span class="linenos">28</span><span class="w">      </span><span class="nt">&lt;Weather</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.5&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Rainy&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">29</span><span class="w">      </span><span class="nt">&lt;Weather</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;0.5&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Snowy&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">30</span><span class="w">    </span><span class="nt">&lt;/Weathers&gt;</span>
<span class="linenos">31</span><span class="w">    </span><span class="nt">&lt;TrafficRules&gt;</span>DE<span class="nt">&lt;/TrafficRules&gt;</span>
<span class="linenos">32</span><span class="w">  </span><span class="nt">&lt;/Environment&gt;</span>
<span class="linenos">33</span><span class="w">  </span><span class="nt">&lt;Observations&gt;</span>
<span class="linenos">34</span><span class="w">    </span><span class="nt">&lt;Observation&gt;</span>
<span class="linenos">35</span><span class="w">      </span><span class="nt">&lt;Library&gt;</span>Observation_Log<span class="nt">&lt;/Library&gt;</span>
<span class="linenos">36</span><span class="w">      </span><span class="nt">&lt;Parameters&gt;</span>
<span class="linenos">37</span><span class="w">        </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;OutputFilename&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;simulationOutput.xml&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">38</span><span class="w">        </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingCyclicsToCsv&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">39</span><span class="w">        </span><span class="nt">&lt;StringVector</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingGroup_Trace&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;XPosition,YPosition,YawAngle&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">40</span><span class="w">        </span><span class="nt">&lt;StringVector</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingGroup_RoadPosition&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;AgentInFront,Lane,PositionRoute,Road,TCoordinate&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">41</span><span class="w">        </span><span class="nt">&lt;StringVector</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingGroup_RoadPositionExtended&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;SecondaryLanes&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">42</span><span class="w">        </span><span class="nt">&lt;StringVector</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingGroup_Sensor&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Sensor*_DetectedAgents,Sensor*_VisibleAgents&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">43</span><span class="w">        </span><span class="nt">&lt;StringVector</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingGroup_Vehicle&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;AccelerationPedalPosition,BrakePedalPosition,EngineMoment,Gear,SteeringAngle,TotalDistanceTraveled,YawRate&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">44</span><span class="w">        </span><span class="nt">&lt;StringVector</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingGroup_Visualization&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;AccelerationEgo,BrakeLight,IndicatorState,LightStatus,VelocityEgo&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">45</span><span class="w">        </span><span class="nt">&lt;StringVector</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;LoggingGroups&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Trace,Visualization,RoadPosition,Sensor&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">46</span><span class="w">      </span><span class="nt">&lt;/Parameters&gt;</span>
<span class="linenos">47</span><span class="w">    </span><span class="nt">&lt;/Observation&gt;</span>
<span class="linenos">48</span><span class="w">    </span><span class="nt">&lt;Observation&gt;</span>
<span class="linenos">49</span><span class="w">      </span><span class="nt">&lt;Library&gt;</span>Observation_EntityRepository<span class="nt">&lt;/Library&gt;</span>
<span class="linenos">50</span><span class="w">      </span><span class="nt">&lt;Parameters&gt;</span>
<span class="linenos">51</span><span class="w">        </span><span class="cm">&lt;!-- If &quot;FilenamePrefix&quot; is skipped, defaults to Value=&quot;Repository&quot; --&gt;</span>
<span class="linenos">52</span><span class="w">        </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;FilenamePrefix&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Repository&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">53</span><span class="w">        </span><span class="cm">&lt;!-- If &quot;WritePersistentEntities&quot; is skipped, defaults to Value=&quot;Consolidated&quot;</span>
<span class="linenos">54</span><span class="cm">             Options: </span>
<span class="linenos">55</span><span class="cm">             - Consolidated: Concatenate with {FilenamePrefix}_Run_###.csv for each run</span>
<span class="linenos">56</span><span class="cm">             - Separate: Write to {FilenamePrefix}_Persistent.csv</span>
<span class="linenos">57</span><span class="cm">             - Skip: No output for persistent entities</span>
<span class="linenos">58</span><span class="cm">        --&gt;</span>
<span class="linenos">59</span><span class="w">        </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;WritePersistentEntities&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Consolidated&quot;</span><span class="nt">/&gt;</span>
<span class="linenos">60</span><span class="w">      </span><span class="nt">&lt;/Parameters&gt;</span>
<span class="linenos">61</span><span class="w">    </span><span class="nt">&lt;/Observation&gt;</span>
<span class="linenos">62</span><span class="w">  </span><span class="nt">&lt;/Observations&gt;</span>
<span class="linenos">63</span><span class="w">  </span><span class="nt">&lt;Spawners&gt;</span>
<span class="linenos">64</span><span class="w">    </span><span class="nt">&lt;Spawner&gt;</span>
<span class="linenos">65</span><span class="w">      </span><span class="nt">&lt;Library&gt;</span>SpawnerPreRunCommon<span class="nt">&lt;/Library&gt;</span>
<span class="linenos">66</span><span class="w">      </span><span class="nt">&lt;Type&gt;</span>PreRun<span class="nt">&lt;/Type&gt;</span>
<span class="linenos">67</span><span class="w">      </span><span class="nt">&lt;Priority&gt;</span>0<span class="nt">&lt;/Priority&gt;</span>
<span class="linenos">68</span><span class="w">      </span><span class="nt">&lt;Profile&gt;</span>DefaultPreRunCommon<span class="nt">&lt;/Profile&gt;</span>
<span class="linenos">69</span><span class="w">    </span><span class="nt">&lt;/Spawner&gt;</span>
<span class="linenos">70</span><span class="w">    </span><span class="nt">&lt;Spawner&gt;</span>
<span class="linenos">71</span><span class="w">      </span><span class="nt">&lt;Library&gt;</span>SpawnerRuntimeCommon<span class="nt">&lt;/Library&gt;</span>
<span class="linenos">72</span><span class="w">      </span><span class="nt">&lt;Type&gt;</span>Runtime<span class="nt">&lt;/Type&gt;</span>
<span class="linenos">73</span><span class="w">      </span><span class="nt">&lt;Priority&gt;</span>0<span class="nt">&lt;/Priority&gt;</span>
<span class="linenos">74</span><span class="w">      </span><span class="nt">&lt;Profile&gt;</span>DefaultRuntimeCommon<span class="nt">&lt;/Profile&gt;</span>
<span class="linenos">75</span><span class="w">    </span><span class="nt">&lt;/Spawner&gt;</span>
<span class="linenos">76</span><span class="w">  </span><span class="nt">&lt;/Spawners&gt;</span>
<span class="linenos">77</span><span class="nt">&lt;/simulationConfig&gt;</span>
</pre></div>
</div>
</div>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="scenery.html" class="btn btn-neutral float-left" title="Scenery" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../outputs/observation_log.html" class="btn btn-neutral float-right" title="Observation_Log" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>